DECLARE FUNCTION HardNumber! (C!)
DECLARE SUB LoadIcons ()
DECLARE SUB SaveBDT (file2$)
DECLARE FUNCTION InMap% (X AS INTEGER, Y AS INTEGER)
DECLARE SUB SaveUDT (path$, wld!)
DECLARE SUB Script (st$, retn!, oldname$, speaker!)
DECLARE FUNCTION CalcRot! (ux!, uy!, mx!, my!)
DECLARE FUNCTION CheckAdjacent% (px1!, py1!, px2!, py2!)
DECLARE FUNCTION Collide! (X!, Y!)
DECLARE FUNCTION Dist! (X1!, Y1!, x2!, y2!)
DECLARE SUB DrawGuys ()
DECLARE SUB Drawmap (mapno!, Mode!, tileX!, tileY!)
DECLARE FUNCTION GROUND! (X!, Y!)
DECLARE FUNCTION GuyAtSqr! (X!, Y!)
DECLARE FUNCTION MapGlobalX! (map AS INTEGER)
DECLARE FUNCTION MapGlobalY! (map AS INTEGER)
DECLARE SUB MINPUT (Text$, Init$)
DECLARE SUB MSG (MSG1$)
DECLARE SUB Pause ()
DECLARE SUB UpdateTempMap (map!)
DECLARE FUNCTION WhichMap! (X!, Y!)
DECLARE SUB DrawBar ()
DECLARE SUB DoConsole (a$)
DECLARE SUB ModeGuy (i!)
'$INCLUDE: 'cdm.bi' 'ENG
' FutureTileEngine
'$INCLUDE: 'future.bi'

DIM SHARED msgs$(24)
DIM SHARED grass(90)
DIM SHARED dirt(90)
DIM SHARED tree(90)
DIM SHARED tree2(90)
DIM SHARED stump(90)
DIM SHARED fire1(90)
DIM SHARED fire2(90)
DIM SHARED fire3(90)
DIM SHARED lastfire
DIM SHARED water(90)
DIM SHARED floor(90)
DIM SHARED cobble(90)
DIM SHARED ffield(90)
DIM SHARED brick(90)
DIM SHARED grind(90)
DIM SHARED flour(90)
DIM SHARED rock(90)
DIM SHARED furnace(90)
DIM SHARED anvil(90)
DIM SHARED bench(90)
DIM SHARED sign(90)
DIM SHARED fishspot(90)
DIM SHARED woodwall(90)
DIM SHARED grass2(90)
DIM SHARED rock2(90)
DIM SHARED rockW(90)
DIM SHARED rockw2(90)
DIM SHARED tiles(90)
DIM SHARED lava(90)
DIM SHARED snow(90)
DIM SHARED snowtree(90)

ON ERROR GOTO errordo2

errordo2:
 MSG "ERROR in engine" + STR$(ERR)
RESUME 20

20
ReSetScreen
PRINT "What happened ... ?"

FUNCTION CalcRot (ux, uy, mx, my)
 IF mx > ux AND my >= uy THEN quad = 1
 IF mx < ux AND my >= uy THEN quad = 2
 IF my < uy AND mx >= ux THEN quad = 4
 IF mx < ux AND my <= uy THEN quad = 3
 dx = mx - ux
 dy = my - uy
 IF dx <> 0 AND dy <> 0 THEN
  theta = ATN(dy / dx) * (180 / pi)
 END IF
 IF quad = 0 THEN theta = 90
 IF quad = 2 THEN theta = theta + 180
 IF quad = 3 THEN theta = theta + 180
 IF quad = 4 THEN theta = theta + 360
 IF theta = 360 THEN theta = 0
 IF quad = 4 AND theta = 0 THEN theta = 270
 theta = CINT(theta)
 CalcRot = theta
END FUNCTION

FUNCTION CheckAdjacent% (px1, py1, px2, py2)
 ' Use pythagoras theorem
 a = px1 - px2
 B = py1 - py2
 C = SQR((a ^ 2) + (B ^ 2))
 IF C = 1 THEN CheckAdjacent% = 1 ELSE CheckAdjacent% = 0
 IF px1 = px2 AND py1 = py2 THEN CheckAdjacent% = 2
END FUNCTION

FUNCTION Collide (X, Y)
 Future.MouseOff
IF mounted = 0 THEN
 SetPage 2
 C = Future.POINT(X + 1, Y + 1)
 
 IF C < 97 OR C > 127 THEN Collide = 0 ELSE Collide = -1
 IF C > 199 AND C < 208 THEN Collide = -1
 IF C < 40 THEN Collide = -1

 SetPage Primary%
ELSE
 SetPage 2
 C = Future.POINT(X + 1, Y + 1)
 C2 = Future.POINT(X + 1, Y + 2)
 C3 = Future.POINT(X + 2, Y + 1)
 C4 = Future.POINT(X + 2, Y + 2)

 IF C < 97 OR C > 127 THEN Collide = 0 ELSE Collide = -1: GOSUB endof
 IF C > 199 AND C < 208 THEN Collide = -1: GOSUB endof
 IF C < 40 THEN Collide = -1: GOSUB endof
 
 IF C2 < 97 OR C2 > 127 THEN Collide = 0 ELSE Collide = -1: GOSUB endof
 IF C2 > 199 AND C2 < 208 THEN Collide = -1: GOSUB endof
 IF C2 < 40 THEN Collide = -1: GOSUB endof
 GOSUB endof
 IF C3 < 97 OR C3 > 127 THEN Collide = 0 ELSE Collide = -1: GOSUB endof
 IF C3 > 199 AND C3 < 208 THEN Collide = -1: GOSUB endof
 IF C3 < 40 THEN Collide = -1: GOSUB endof
 GOSUB endof
 IF C4 < 97 OR C4 > 127 THEN Collide = 0 ELSE Collide = -1
 IF C4 > 199 AND C4 < 208 THEN Collide = -1
 IF C4 < 40 THEN Collide = -1
endof:
 SetPage Primary%
END IF
 Future.MouseOn
END FUNCTION

FUNCTION Dist (X1, Y1, x2, y2)
 X1 = ABS(X1)
 x2 = ABS(x2)
 Y1 = ABS(Y1)
 y2 = ABS(y2)
 Dist = SQR((X1 - x2) ^ 2 + (Y1 - y2) ^ 2)
END FUNCTION

SUB DrawGuys
 FOR i = 1 TO maxunits
  IF unit(i).HP > 0 AND unit(i).rank >= 0 THEN
   IF unit(i).THP = 0 THEN unit(i).THP = 1
'   unit(i).map = WhichMap(INT(unit(i).X), INT(unit(i).y))
   IF InMap%(INT(unit(i).X), INT(unit(i).Y)) THEN
     ux = unit(i).X - INT(Xscroll%) ' previously was checking with mapglobalX
     uy = unit(i).Y - INT(Yscroll%)
     SELECT CASE unit(i).rank
      CASE 20
       ' moooooo
       Future.XMSArrayPut ux * 15, uy * 15, Icons%, 53
      CASE 21
       ' neighhay
       Future.XMSArrayPut ux * 15, uy * 15, Icons%, 206
      CASE 22
       ' buuuurk buk buk buk
       Future.XMSArrayPut ux * 15 + 1, uy * 15 + 1, Icons%, 104
      CASE 19
       ' fire
        iconP% = unit(i).Tx
        Future.XMSArrayPut ux * 15, uy * 15, sprs%, iconP%
      CASE 0
       IF i = selu THEN
        Future.BOX ux * 15, uy * 15 + 1, ux * 15 + 14, uy * 15 + 14, 9
        Future.FILLBOX ux * 15 + 1, uy * 15, ux * 15 + 14, uy * 15 + 1, 4
        Future.FILLBOX ux * 15 + ((unit(i).HP / unit(i).THP) * 14), uy * 15, ux * 15, uy * 15 + 1, 2
       END IF
       Future.PUT ux * 15 + 4, uy * 15, pD()
      CASE 1
    '   IF I = selu THEN
    '    Future.BOX ux * 15, uy * 15 + 1, ux * 15 + 14, uy * 15 + 14, 9
    '    Future.FILLBOX ux * 15 + 1, uy * 15, ux * 15 + 14, uy * 15 + 1, 4
    '    Future.FILLBOX ux * 15 + ((unit(I).HP / unit(I).THP) * 14), uy * 15, ux * 15, uy * 15 + 1, 2
    '   END IF
       IF mounted = 0 THEN
        Future.PUT ux * 15 + 3, uy * 15, player()
       ELSEIF mounted = 1 THEN
        Future.XMSArrayPut ux * 15 + 1, uy * 15, Icons%, 207
       ELSEIF mounted = 2 THEN
        Future.XMSArrayPut ux * 15 + 1, uy * 15, Icons%, 208
       END IF
      CASE 2
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, 5
      CASE 3
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, 4
      CASE 4
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 18
      CASE 10
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 19
      CASE 98
       Future.XMSArrayPut ux * 15 - 15, uy * 15 - 15, Icons%, 153
      CASE 25
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, unit(i).Icon
      CASE 5
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 12
      CASE 6
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 11
      CASE 17
       ' monster
       IF unit(i).Skill = 7 THEN
        ' big dwagon
        IF Skill(6).Level < 43 THEN
         IF Dist(unit(i).X + 0, unit(i).Y + 0, unit(selu).X + 0, unit(selu).Y + 0) < 10 THEN
        '  MSG "You wet your pants."
          unit(selu).Tx = unit(selu).Tx - 10
          unit(selu).Ty = unit(selu).Ty - 10
         END IF
        END IF
       END IF
       SELECT CASE monst(unit(i).Skill).Size
        CASE 1
         Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, unit(i).Icon
        CASE 2
         Future.XMSArrayPut ux * 15 + 1, uy * 15, Icons%, unit(i).Icon
        CASE 4
         Future.XMSArrayPut ux * 15 - 15, uy * 15 - 15, size64x%, unit(i).Icon
       END SELECT
      CASE ELSE
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, unit(i).Icon
     END SELECT
   END IF
   END IF' on currentmap
 NEXT i
END SUB

SUB Drawmap (mapno, Mode, tileX, tileY)
 
Future.MouseOff
 SetPage Secondary%
 gmx = MapGlobalX(currentmap + 0)
 gmy = MapGlobalY(currentmap + 0)


 IF Mode = 2 THEN GOSUB tileonly

 IF mapno <= 10 OR (mapno > 90 AND mapno <= 100) OR RIGHT$(STR$(mapno), 1) = "1" OR RIGHT$(STR$(mapno), 1) = "0" THEN
  onEdgeWorld$ = "1"
 ELSE
  onEdgeWorld$ = "1"
 END IF


 map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
 
   'mapchar$(i, y) = char$
 MSG ""
tileonly:
  i = 0
  FOR X1 = 1 + Xscroll% TO 40 + Xscroll%
   i = i + 1
   Y = 0
  FOR Y1 = 1 + Yscroll% TO 25 + Yscroll%
   Y = Y + 1
   IF Mode = 2 THEN
    i = tileX - Xscroll%
    Y = tileY - Yscroll%
        'char$ = mapchar$(i, Y)
        '  x2 = i + gmx - 1
        '  y2 = y + gmy - 1
    char$ = CHR$(GROUND(tileX - 1, tileY - 1))
   ELSE
    SetPage 2
    C = Future.POINT(X1, Y1)
    IF C < 1 OR C > 255 THEN C = 1
    char$ = CHR$(C)
    SetPage Secondary%
   END IF
   SELECT CASE char$
    CASE "G"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), grass()
    CASE "D"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), dirt()
    CASE "t"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), tree()
    CASE "{"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), tree2()
    CASE "^"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), stump()
    CASE "f"
     SELECT CASE lastfire
      CASE 1
       Future.PUT ((i - 1) * 15), ((Y - 1) * 15), fire1()
      CASE 2
       Future.PUT ((i - 1) * 15), ((Y - 1) * 15), fire2()
      CASE ELSE
       Future.PUT ((i - 1) * 15), ((Y - 1) * 15), fire3()
     END SELECT
     IF lastfire = 3 THEN lastfire = 0
     lastfire = lastfire + 1
    CASE "w"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), water()
    CASE "/"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), floor()
    CASE "C"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), cobble()
    CASE "F"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), ffield()
    CASE "b"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), brick()
    CASE "g"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), grind()
    CASE "@"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), flour()
    CASE "r", "", "", "", "", "", "", "", ""
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), rock()
     SELECT CASE char$
      CASE "r"
        Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 6, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 7, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 185, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 170, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 14, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 176, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 144, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 3, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((Y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((Y - 1) * 15 + 14), 15, -1
     END SELECT
    CASE "j"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), furnace()
    CASE "a"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), anvil()
    CASE "|"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), bench()
    CASE "S"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), sign()
    CASE "y"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), fishspot()
    CASE "o"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), fishspot()
    CASE "l"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), woodwall()
    CASE "H"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), grass2()
    CASE "q"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), rock2()
    CASE "u"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), rockW()
    CASE "T"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), tiles()
    CASE "e"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), lava()
    CASE "E"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), snow()
    CASE "i"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), snowtree()
    CASE "v"
     Future.PUT ((i - 1) * 15), ((Y - 1) * 15), rockw2()
    CASE IS > CHR$(128)
     Future.XMSArrayPut ((i - 1) * 15), ((Y - 1) * 15), csets%, (ASC(char$) - 128)
    CASE ELSE
     IF char$ <> "" THEN
      'LINE ((i - 1) * 15), ((Y - 1) * 15)-((i - 1) * 15 + 14, (Y - 1) * 15 + 14), 0, BF
     Future.XMSArrayPut ((i - 1) * 15), ((Y - 1) * 15), csets%, 34
     END IF
   END SELECT
   IF Mode = 2 THEN SetPage Primary%: Future.MouseOn: EXIT SUB
  NEXT Y1
  NEXT X1
 'LOOP
 CLOSE ff
 ff = FREEFILE
  OPEN "data\labl" + STR$(world) + ".dat" FOR APPEND AS #ff: CLOSE ff
  OPEN "data\labl" + STR$(world) + ".dat" FOR INPUT AS #ff
  DO UNTIL EOF(ff)
   INPUT #ff, M, X, Y, C, t$
   IF InMap%(X + 0, Y + 0) THEN
    Future.PRINT (X - gmx) * 15, (Y - gmy) * 15, t$, C + 0, -1
   END IF
  LOOP
 CLOSE #ff
 IF Mapedit = 0 THEN DrawGuys
' MSG STR$(Xscroll%) + STR$(Yscroll%)
 SWAP Secondary%, Primary%
 SetPage Primary%
 ViewPage Primary%
 Future.MouseOn
END SUB

FUNCTION GROUND (X, Y)
Future.MouseOff
 SetPage 2
 C = Future.POINT(X + 1, Y + 1)
 IF C < 1 OR C > 255 THEN C = 1
 GROUND = C
 SetPage Primary%
Future.MouseOn
END FUNCTION

FUNCTION GuyAtSqr (X, Y)
FOR i = 1 TO 100' 100 is THE max number of units... ever
 IF unit(i).HP > 0 THEN
  IF unit(i).X = X AND unit(i).Y = Y THEN
   GuyAtSqr = i
  END IF
 END IF
NEXT i
END FUNCTION

FUNCTION HardNumber (C)
 IF C < 97 OR C > 127 THEN HardNumber = 0 ELSE HardNumber = -1
 IF C > 199 AND C < 208 THEN HardNumber = -1
 IF C < 40 THEN HardNumber = -1
END FUNCTION

SUB HMapEditKeys
 jkl$ = INKEY$
 SELECT CASE jkl$
  CASE CHR$(0) + "I"
   schar$ = CHR$(ASC(schar$) + 1)
   MSG schar$ + " selected"
  CASE CHR$(0) + "Q"
   schar$ = CHR$(ASC(schar$) - 1)
   MSG schar$ + " selected"
  CASE "q"
   Mapedit = 0
  CASE CHR$(27)
   MSG "Press Q to exit mapedit mode"
  MINPUT file2$, "Save as:"
   IF file2$ <> "" THEN
    SaveBDT file2$
    MSG " MAP SAVED: Press any key to continue..."
    Pause
    Drawmap currentmap, 1, 0, 0
   END IF
   MSG "Its is strongly recommended that you reload the map"
  CASE CHR$(0) + "K"
     Xscroll% = Xscroll% - 20
     currentmap = currentmap - 1
     Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "M"
      Xscroll% = Xscroll% + 20
      currentmap = currentmap + 1
      playerX = 1
      Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "H"
     Yscroll% = Yscroll% - 12
     currentmap = currentmap - 10
     playerY = 12 * 15
     Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "P"
     Yscroll% = Yscroll% + 12
     currentmap = currentmap + 10
     playerY = 1
     Drawmap currentmap, 1, 0, 0
  CASE "!"
   MINPUT a$, ""
   DoConsole a$
  CASE "`"
   MINPUT console$, "->"
   SELECT CASE console$
    CASE "info"
     MSG "INFO"
     MSG "mapudt - saves current world udt to maps\"
     MSG "plyudt - saves current world udt to player\ (Caution, player must exist)"
     MSG "blkudt - clears all units & plots,then saves blank world udt to maps\"
    CASE "mapudt"
     SaveUDT "maps\", world
    CASE "blkudt"
     FOR i = 2 TO 100
      unit(i).rank = -1
     NEXT i
     SaveUDT "maps\", world

    CASE "unit"
     FOR i = 1 TO maxunits
      IF unit(i).HP = 0 OR unit(i).rank = -1 THEN
       iNewUnit% = i
       EXIT FOR
      END IF
     NEXT i

     MSG "Place New unit"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)

     unit(iNewUnit%).X = X1
     unit(iNewUnit%).Y = Y1

     MINPUT a$, "Rank:"
     unit(iNewUnit%).rank = VAL(a$)
     MINPUT a$, "Name:"
     unit(iNewUnit%).Name = a$
     MINPUT a$, "Icon:"
     unit(iNewUnit%).Icon = VAL(a$)
     unit(iNewUnit%).HP = 10
     unit(iNewUnit%).THP = 10
     MSG "Use UDTEDIT to edit this unit properly"
    CASE "plot"
     MSG "place left-upper..."
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)
 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... place right-lower"
 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   x2 = mxs + mpx
   y2 = mys + mpy
   EXIT DO
  END IF
 LOOP
    MSG STR$((X1 - x2) * (Y1 - y2))
    MINPUT o$, "Owner#:"
    MINPUT C$, "Cost$#:"
    CLOSE : OPEN "data\plt" + STR$(world) + ".dat" FOR APPEND AS #1
     WRITE #1, X1, Y1, x2, y2, VAL(o$), VAL(C$)
    CLOSE
  CASE "mapedit"
   IF Mapedit = 1 THEN Mapedit = 0 ELSE Mapedit = 1
  CASE "warp"
   MINPUT C$, "map 1-100:"
   currentmap = VAL(C$)
   Drawmap currentmap, 1, 0, 0
  CASE "ghost"
   INPUT "ghost:", ghost
  CASE "tile"
   INPUT "tileset:", tileset$
  CASE "save"
  INPUT " Recompile?(r)=yes", rd$
  IF rd$ = "r" THEN
  INPUT " File:", file2$
  IF file2$ = "" THEN
   PRINT " Recompile as world "; world; "?(r)=yes";
   INPUT rd2$
   IF rd2$ = "r" THEN file2$ = "maps\world" + STR$(world) + ".bd2"
  END IF
 
  CLOSE
  OPEN file2$ FOR OUTPUT AS #1
  WRITE #1, tileset$
  FOR mapno = 1 TO 100
   map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
   OPEN map$ FOR INPUT AS #2
    FOR i = 1 TO 13
     INPUT #2, line$
     PRINT #1, line$
    NEXT i
   CLOSE #2
  
   LOCATE 1, 1
   PRINT mapno; "%"
   NEXT mapno
   PRINT " Press any key to continue..."
   Pause
   Drawmap currentmap, 1, 0, 0
  END IF
  CASE "q"
   INPUT "Type:(e.g. goblin,eman1)", Type$
   INPUT "Name:(optional)", Name$
   INPUT "HP(optional)", HP
   IF HP = 0 THEN HP = 10
   CLOSE
   MSG " Place AI " + Type$
   DO
    MouseStatus Lb%, Rb%, xm%, ym%: MouseShow
    MouseRange 1, 1, 640, 480
   LOOP UNTIL Lb% = -1
   X = INT((xm% / 2) / 15) + 1
   Y = INT(ym% / 15) + 1
   MSG " AT " + STR$(X) + STR$(Y)
   OPEN "data\quest 1.dat" FOR APPEND AS #1
    WRITE #1, Type$, X, Y, currentmap, HP, 1, Name$, world
   CLOSE
  
   Drawmap currentmap, 1, 0, 0
  CASE "addtile"
   'NewTile


  CASE "vumap"
   Future.MouseOff
  
   FOR mapno = 1 TO 100
   map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
   CLOSE
   OPEN map$ FOR INPUT AS #1
   X = 0
    DO UNTIL EOF(1)
    X = X + 1
    INPUT #1, line$
    FOR i = 1 TO LEN(line$)
     ch$ = MID$(line$, i, 1)
     Future.PSET i + M, X + m2, ASC(ch$) + 0
    NEXT i
   LOOP
   CLOSE
   M = M + 40
   IF RIGHT$(STR$(mapno), 1) = "0" THEN
    M = 0
    m2 = m2 + 25
   END IF
   NEXT mapno
   Future.MouseOn
   DO
    Future.UpdateMouse
    xm% = Future.MouseX%
    ym% = Future.MouseY%
    IF Future.MouseB% = 1 THEN
     Future.FILLBOX xm% - 1, ym% - 1, xm% - sz, ym% - sz, stc + 0
    END IF
   jkl$ = INKEY$
   SELECT CASE jkl$
    CASE CHR$(27)
  MINPUT rd$, " Save?(y=yes bd2) (3=yes bd3)"
  IF rd$ = "y" OR rd$ = "3" THEN
   MINPUT file2$, " File:"
   IF rd$ = "3" THEN
    'PRINT "Saved as bd3 on " + DATE$ + TIME$
    xts = 40
    yts = 25
   ELSE
    xts = 21
    yts = 13
   END IF
   X = 0
   M = 0
   m2 = 0
   Future.MouseOff
   CLOSE
   OPEN file2$ FOR OUTPUT AS #1
    WRITE #1, tileset$
    FOR mapno = 1 TO 100
     Y = 0
     FOR X = 1 TO yts
      Y = Y + 1
      line$ = ""
       FOR i = 1 TO xts
        ac = Future.POINT(i + M, Y + m2)
        IF ac < 1 OR ac > 254 THEN ac = ASC("G")
        line$ = line$ + CHR$(ac)
       NEXT i
      WRITE #1, line$
     NEXT X
     M = M + xts
     IF RIGHT$(STR$(mapno), 1) = "0" THEN
      M = 0
      m2 = m2 + yts
     END IF
    NEXT mapno
   Future.MouseOff
  END IF
     Drawmap currentmap, 1, 0, 0
     EXIT DO
    CASE "-"
     sz = sz + 1
    CASE "="
     sz = sz - 1
    CASE ELSE
     IF jkl$ <> "" THEN
      stc = ASC(jkl$)
     END IF
   END SELECT
   LOOP
  CASE "newmap"
   'LoadWorld "maps\blank.bd2"
  CASE "world"
   INPUT "World:", world
   world$ = "maps\world" + STR$(world) + ".bd2"
   currentquest = world
   LoadMaps world$
  CASE "vutemp"
  
   FOR X = 1 TO 21
    FOR Y = 1 TO 13
     PSET (X, Y), ASC(mapchar$(X, Y))
    NEXT
   NEXT
   Pause
  END SELECT
  CASE ELSE
   IF jkl$ <> "" THEN
    schar$ = jkl$
   END IF
 END SELECT

END SUB

FUNCTION InMap% (X AS INTEGER, Y AS INTEGER)
InMap% = 0
IF X% >= Xscroll% AND X% <= Xscroll% + 39 THEN
 IF Y% >= Yscroll% AND Y% <= Yscroll% + 24 THEN
  InMap% = -1
 END IF
END IF
END FUNCTION

SUB LoadIcons
 DIM xo AS INTEGER, yo AS INTEGER
 CLOSE
 ViewPage Primary%
 SetPage Primary%
 Future.PRINT 50, 260, "Loading icons...", 15, 0
 SetPage Secondary%
 Future.LoadBMP "sprites\sc1.bmp", 0, 0
 z = 0
 DO
  z = z + 1
  Future.XMSarrayGET xo, yo, Icons%, INT(z)
  xo = xo + 32
  IF xo >= 640 THEN xo = 0: yo = yo + 32
 LOOP UNTIL yo >= 480
 Future.CLS 0
 SetPage Primary%
 Future.CLS 0
END SUB

SUB LoadMaps (file$)
Future.CLS 0
SetPage Primary%
 CLOSE
 'PRINT file$
 OPEN file$ FOR APPEND AS #1
 IF LOF(1) < 1 THEN
  SLEEP
  Future.PRINT 10, 10, "Map file " + file$ + " not found.", 155, 0
  CLOSE
  KILL file$
  file$ = "maps\world 1.bd3"
 END IF
 CLOSE
 OPEN file$ FOR INPUT AS #1
 INPUT #1, tileset$
 FOR mapno = 1 TO 100
  map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
  OPEN map$ FOR OUTPUT AS #2
   FOR i = 1 TO 25
    INPUT #1, line$
    PRINT #2, line$
   NEXT i
  CLOSE #2
  
'   Future.LINE 40, 80, 40 + 100, 80, 4, -1
'   Future.LINE 40, 80, 40 + mapno, 80, 2, -1
 NEXT mapno
 CLOSE
IF dmaps = 0 THEN
SetPage 2
      Future.CLS 16
      FOR mapno = 1 TO 100
        map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
        CLOSE
        M = M + 40
        OPEN map$ FOR INPUT AS #1
        X = 0
        DO UNTIL EOF(1)
         X = X + 1
         INPUT #1, line$
         FOR i = 1 TO LEN(line$)
          ch$ = MID$(line$, i, 1)
          Future.PSET i + M - 40, X + m2, ASC(ch$)
         NEXT i
       LOOP
       CLOSE
       IF RIGHT$(STR$(mapno), 1) = "0" THEN
        M = 0
        m2 = m2 + 25
       END IF
       SetPage Primary%
     '   Future.LINE 40, 90, 40 + 100, 90, 4, -1
     '   Future.LINE 40, 90, 40 + mapno, 90, 2, -1
       SetPage 2
     NEXT mapno
SetPage Secondary%
END IF
END SUB

SUB LoadSpr (pic$, Array(), cfrom, cto)
  CLOSE
  Future.CLS 0
  OPEN "sprites\" + pic$ FOR INPUT AS #1
  DO UNTIL EOF(1)
   INPUT #1, X, Y, C
   IF C = cfrom THEN C = cto
   Future.PSET X, Y, C
  LOOP
  CLOSE #1
  Future.GET 0, 0, 15, 15, Array()
END SUB

SUB LoadTiles
 ViewPage Primary%
 SetPage Primary%
 Future.PRINT 50, 240, "Loading tiles...", 15, 0
 SetPage Secondary%
 'ViewPage Secondary%
 Xs% = 14
 Ys% = 14
 Future.LINE 0, 0, Xs% + 2, Ys% + 2, 5, 1
 OPEN "data\" + tileset$ FOR INPUT AS #1
 DO UNTIL EOF(1)
  IF INP(96) = 59 THEN
   CLOSE
   EXIT DO
  END IF
  tileno = tileno + 1
  INPUT #1, tile$
  Future.FILLBOX 0, 0, 64, 64, 0
'  SetPage Primary%
'   Future.FILLBOX 40, 70, 40 + 251, 77, 4
'   Future.FILLBOX 40, 70, 40 + tileno, 77, 2
'  SetPage Secondary%
 IF RIGHT$(tile$, 3) <> "ico" THEN
  OPEN "sprites\" + tile$ FOR INPUT AS #2
  C2 = 0
  IF RIGHT$(tile$, 3) = "mdg" THEN C2 = 15
  DO UNTIL EOF(2)
   INPUT #2, X, Y, C
   IF C2 > 0 THEN C = C2
   'IF RIGHT$(tile$, 3) = "ico" AND startmode = 1 THEN EXIT DO
   Future.PSET X, Y, C
  LOOP
  CLOSE #2
  SELECT CASE tileno
   CASE 1
    Future.GET 0, 0, Xs%, Ys%, grass()
   CASE 2
    Future.GET 0, 0, Xs%, Ys%, dirt()
   CASE 3
    Future.GET 0, 0, Xs%, Ys%, tree()
   CASE 4
    Future.GET 0, 0, Xs%, Ys%, tree2()
   CASE 5
    Future.GET 0, 0, Xs%, Ys%, stump()
   CASE 6
    Future.GET 0, 0, Xs%, Ys%, fire1()
   CASE 7
    Future.GET 0, 0, Xs%, Ys%, fire3()
   CASE 8
    Future.GET 0, 0, Xs%, Ys%, fire3()
   CASE 9
    Future.GET 0, 0, Xs%, Ys%, water()
   CASE 10
    Future.GET 0, 0, Xs%, Ys%, floor()
   CASE 11
    Future.GET 0, 0, Xs%, Ys%, cobble()
   CASE 12
    Future.GET 0, 0, Xs%, Ys%, ffield()
   CASE 13
    Future.GET 0, 0, Xs%, Ys%, brick()
   CASE 14
    Future.GET 0, 0, Xs%, Ys%, grind()
   CASE 15
    Future.GET 0, 0, Xs%, Ys%, flour()
   CASE 16
    Future.GET 0, 0, Xs%, Ys%, rock()
   CASE 17
    Future.GET 0, 0, Xs%, Ys%, furnace()
   CASE 18
    Future.GET 0, 0, Xs%, Ys%, anvil()
   CASE 19
    Future.GET 0, 0, Xs%, Ys%, bench()
   CASE 20
    Future.GET 0, 0, Xs%, Ys%, sign()
   CASE 21
    Future.GET 0, 0, Xs%, Ys%, fishspot()
   CASE 22
    Future.GET 0, 0, Xs%, Ys%, woodwall()
   CASE 23
    Future.GET 0, 0, Xs%, Ys%, grass2()
   CASE 24
    Future.GET 0, 0, Xs%, Ys%, rock2()
   CASE 25
    Future.GET 0, 0, Xs%, Ys%, rockW()
   CASE 26
    Future.GET 0, 0, Xs%, Ys%, tiles()
   CASE 27
    Future.GET 0, 0, Xs%, Ys%, lava()
   CASE 28
    Future.GET 0, 0, Xs%, Ys%, snow()
   CASE 29
    Future.GET 0, 0, Xs%, Ys%, snowtree()
   CASE 30
    Future.GET 0, 0, Xs%, Ys%, rockw2()
   CASE IS > 30
    SELECT CASE RIGHT$(tile$, 3)
     CASE "ico"
      icn = icn + 1
      Future.XMSarrayGET 0, 0, Icons%, INT(icn)
     CASE "64x"
      i64 = i64 + 1
      Future.XMSarrayGET 0, 0, size64x%, INT(i64)
     CASE "mdg"
      md = md + 1
      Future.XMSarrayGET 0, 0, mdgs%, INT(md)
     CASE "spi"
      spi = spi + 1
      IF spi = 1 THEN Future.XMSarrayGET 0, 0, sprs%, 0
      Future.XMSarrayGET 0, 0, sprs%, INT(spi)
     CASE "fac"
      fac = fac + 1
      Future.XMSarrayGET 0, 0, handle%, INT(fac)
     CASE ELSE
      ci = ci + 1
      Future.XMSarrayGET 0, 0, csets%, INT(ci)
    END SELECT
  END SELECT
 END IF
 LOOP
 Future.CLS 0
 SetPage Primary%
 LoadIcons
END SUB

FUNCTION MapGlobalX (map AS INTEGER)
'X = INT((map - 1) / 10) * 10
'X = (map - X) * 40
'MapGlobalX = X - 40
 MapGlobalX = Xscroll%
END FUNCTION

FUNCTION MapGlobalY (map AS INTEGER)
 'MapGlobalY = INT((map - 1) / 10) * 25
 MapGlobalY = Yscroll%
END FUNCTION

SUB MiniDigit (X, Y, t$, C)
FOR i = 1 TO LEN(t$)
 ch$ = MID$(t$, i, 1)
 IF ch$ = "0" THEN ch$ = "10"
 IF ch$ = "K" THEN ch$ = "11"
 IF ch$ = "." THEN ch$ = "92"
 IF ch$ = " " THEN ch$ = CHR$(40)
 IF ASC(ch$) > 41 THEN
  IF ASC(ch$) > 63 THEN ch$ = STR$(ASC(ch$) - 65 + 12)
  ch = VAL(ch$)
  IF ch = 92 THEN
   Future.PSET X + (i * 5) + 2, Y + 5, 15
  ELSE
   Future.XMSArrayPut X + (i * 5), Y + 0, mdgs%, ch + 0
  END IF
 END IF
NEXT i
END SUB

SUB MINPUT (Text$, Init$)
 Text$ = ""
 GOSUB RedrawM
 DO
  jkl$ = INKEY$
  SELECT CASE jkl$
   CASE CHR$(13)
    IF Text$ <> "" THEN MSG Text$
    EXIT DO
   CASE CHR$(27)
    Text$ = ""
    IF Text$ <> "" THEN MSG Text$
    EXIT SUB
   CASE CHR$(0) + "H"
    P = P + 1
    Text$ = msgs$(P)
    GOSUB RedrawM
   CASE CHR$(0) + "P"
    P = P - 1
    IF P <= 0 THEN P = 1
    Text$ = msgs$(P)
    GOSUB RedrawM
   CASE CHR$(8)
    IF Text$ <> "" THEN Text$ = LEFT$(Text$, LEN(Text$) - 1)
    GOSUB RedrawM
   CASE IS <> ""
    Text$ = Text$ + jkl$
    GOSUB RedrawM
  END SELECT
 LOOP
 EXIT SUB
RedrawM:
    Future.FILLBOX 1, 460, 600, 480, 164
    Future.PRINT 10, 460, Init$ + Text$ + "", 8, 164
RETURN
END SUB

SUB MoveGuys
 FOR i = 1 TO maxunits
  mvd = 0
  IF unit(i).rank = 19 AND unit(i).HP > 0 THEN
   IF TIME > unit(i).MVT THEN MSG "frozen fire time": TIME = unit(i).MVT
   IF TIME = unit(i).MVT THEN
     unit(i).MVT = TIME + 15
     unit(i).Tx = unit(i).Tx + 1
     IF unit(i).Tx = 4 THEN unit(i).Tx = 1
     unit(i).HP = unit(i).HP - 1
     scnX = INT(unit(i).X + 1): scnY = INT(unit(i).Y + 1)
     Drawmap INT(currentmap), 2, scnX, scnY
     IF unit(i).HP <= 0 THEN unit(i).rank = -1: unit(i).HP = 0
   END IF
  END IF
  IF (unit(i).rank = 20 OR unit(i).rank = 21 OR unit(i).rank = 22) AND unit(i).HP = -1 THEN
   IF TIME > unit(i).MVT THEN MSG "frozen time": TIME = unit(i).MVT
   IF TIME = unit(i).MVT THEN
     unit(i).HP = 10
   END IF
  END IF
  IF (unit(i).rank >= 2 OR unit(i).rank < 19) AND unit(i).HP <= 0 THEN
   IF TIME = unit(i).MVT THEN
     unit(i).HP = unit(i).THP
   END IF
  END IF


  IF (unit(i).rank = 21 OR unit(i).rank = 22) THEN ' cows, chooks etc
  IF InMap%(INT(unit(i).X), INT(unit(i).Y)) THEN
   IF TIME > unit(i).TM THEN unit(i).TM = TIME + 1
   IF TIME = unit(i).TM THEN
    d = INT(RND * 4) + 1
    SELECT CASE d
     CASE 1: xm = -1
     CASE 2: xm = 1
     CASE 3: ym = -1
     CASE 4: ym = 1
    END SELECT
    CX = unit(i).X + xm
    CY = unit(i).Y + ym
    IF NOT Collide(CX, CY) THEN
     'Drawmap INT(currentmap), 2, INT(unit(i).X - MapGlobalX(unit(i).map)), INT(unit(i).y - MapGlobalY(unit(i).map))
     scnX = INT(unit(i).X + 1): scnY = INT(unit(i).Y + 1)
     Drawmap INT(currentmap), 2, scnX, scnY
     IF unit(i).rank = 21 THEN
       Drawmap INT(currentmap), 2, INT(unit(i).X + 1), INT(unit(i).Y + 2)
       Drawmap INT(currentmap), 2, INT(unit(i).X + 2), INT(unit(i).Y + 1)
       Drawmap INT(currentmap), 2, INT(unit(i).X + 2), INT(unit(i).Y + 2)
     END IF
'     MSG STR$(scnX) + STR$(scnY) + " for old chooken #" + STR$(i)
     unit(i).X = CX
     unit(i).Y = CY
     unit(i).TM = TIME + INT(RND * 140) + 31
    END IF
   END IF
  END IF'InMap
  END IF

  IF (unit(i).rank > 1 AND unit(i).rank < 19) AND unit(i).Mode > 1 THEN
   IF unit(i).X = unit(i).Tx + 0 AND unit(i).Y + 0 = unit(i).Ty + 0 THEN
    IF unit(i).Mode <> 7 THEN unit(i).Mode = 0
   END IF
  ' move intelligent ai... well, the ones that aim somewhere at least
   IF TIME > unit(i).MVT THEN unit(i).MVT = TIME + 5
   IF TIME = unit(i).MVT THEN

    d = Dist(unit(i).X + 0, unit(i).Y + 0, unit(i).Tx + 0, unit(i).Ty + 0)
    IF d < 27 THEN
    ' ^else give up chase

    IF unit(i).X < unit(i).Tx THEN d = 2 ' Precedence is 1 and 3, left & up
    IF unit(i).X > unit(i).Tx THEN d = 1
    IF unit(i).Y < unit(i).Ty THEN d = 4
    IF unit(i).Y > unit(i).Ty THEN d = 3
otherway:
    SELECT CASE d
     CASE 1: xm = -1
     CASE 2: xm = 1
     CASE 3: ym = -1
     CASE 4: ym = 1
    END SELECT
    CX = unit(i).X + xm
    CY = unit(i).Y + ym
    IF NOT Collide(CX, CY) THEN
     IF InMap%(INT(unit(i).X), INT(unit(i).Y)) THEN
      scnX = INT(unit(i).X + 1): scnY = INT(unit(i).Y + 1)
      Drawmap INT(currentmap), 2, scnX, scnY
     END IF
     unit(i).X = CX
     unit(i).Y = CY
     unit(i).MVT = TIME + 10
    ELSE
     IF try < 4 THEN
      try = try + 1
      IF unit(i).X > unit(i).Tx THEN d = 1 ' Precedence is 2 and 4, right & down
      IF unit(i).X < unit(i).Tx THEN d = 2
      IF unit(i).Y > unit(i).Ty THEN d = 3
      IF unit(i).Y < unit(i).Ty THEN d = 4
      GOSUB otherway
     END IF
     IF try < 7 THEN
      try = try + 1
      d = d + 1
      d = INT(RND * 4) + 1
      IF d > 4 THEN d = 1
      GOSUB otherway
     END IF
    END IF
    END IF
   END IF
  END IF


  IF unit(i).HP > 0 THEN
   ModeGuy i
   IF unit(i).MVT = TIME AND unit(i).rank < 99 THEN
    'unit(i).map = WhichMap(INT(unit(i).X), INT(unit(i).y))
    IF InMap%(INT(unit(i).X), INT(unit(i).Y)) THEN
     IF i = selu THEN
      IF onEdgeWorld$ = "1" THEN
       IF unit(1).X = 0 OR unit(1).X = 399 OR unit(1).Y = 0 OR unit(1).Y = 249 THEN
        onEdgeMap$ = "1"
       ELSE
        onEdgeMap$ = "0"
       END IF
      END IF
      'Future.PUT INT(unit(i).X - MapGlobalX(unit(i).map)) * 15, INT(unit(i).Y - MapGlobalY(unit(i).map)) * 15, playerBKG()
      'Drawmap INT(currentmap), 2, INT(unit(i).X + 1 - Xscroll%), INT(unit(i).y + 1 - Yscroll%)
      Drawmap INT(currentmap), 2, INT(unit(i).X + 1), INT(unit(i).Y + 1)
      IF mounted THEN
       Drawmap INT(currentmap), 2, INT(unit(i).X + 1), INT(unit(i).Y + 2)
       Drawmap INT(currentmap), 2, INT(unit(i).X + 2), INT(unit(i).Y + 1)
       Drawmap INT(currentmap), 2, INT(unit(i).X + 2), INT(unit(i).Y + 2)
      END IF
     ELSE
      'Drawmap INT(currentmap), 2, INT(unit(i).X + 1 - Xscroll%), INT(unit(i).y + 1 - Yscroll%)
      Drawmap INT(currentmap), 2, INT(unit(i).X + 1), INT(unit(i).Y + 1)
     END IF
    END IF
    IF (unit(i).X <> unit(i).Tx OR unit(i).Y <> unit(i).Ty) THEN
     IF unit(i).Mode <> 5 THEN
       CX = unit(i).X
       CY = unit(i).Y
      FOR z = 1 TO 120
       SELECT CASE MID$(USERWPT$, z, 1)
        CASE "w"
         CY = CY - 1
         C = 1
         EXIT FOR
        CASE "s"
         CY = CY + 1
         C = 2
         EXIT FOR
        CASE "a"
         CX = CX - 1
         C = 3
         IF mounted THEN mounted = 1
         EXIT FOR
        CASE "d"
         CX = CX + 1
         C = 4
         IF mounted THEN mounted = 2
         EXIT FOR
        CASE "-"
         C = 0
        CASE ELSE
         C = 0
       END SELECT
      NEXT z
      IF C > 0 AND NOT Collide(CX, CY) THEN
       unit(i).X = CX
       unit(i).Y = CY
       unit(i).MVT = TIME + unit(i).Spd + bAc
       'Future.GET INT(unit(i).X - MapGlobalX(unit(i).map)) * 15, INT(unit(i).Y - MapGlobalY(unit(i).map)) * 15, INT(unit(i).X - MapGlobalX(unit(i).map)) * 15 + 15, INT(unit(i).Y - MapGlobalY(unit(i).map)) * 15 + 15, playerBKG()
       MID$(USERWPT$, z) = "-"
      END IF
     END IF
    END IF
   END IF

  END IF
 NEXT i
END SUB

SUB MSG (MSG1$)

Future.FILLBOX 1, 375, 600, 479, 223
Future.BOX 1, 375, 599, 479, 20
Future.BOX 2, 376, 598, 478, 23
Future.BOX 3, 377, 597, 477, 26
Future.BOX 5, 378, 596, 476, 23
Future.BOX 6, 379, 595, 475, 20
IF MSG1$ <> "" THEN
 FOR i = 20 TO 2 STEP -1
  msgs$(i) = msgs$(i - 1)
 NEXT i
 msgs$(1) = MSG1$
END IF
FOR i = 1 TO 5
 G = i + mscroll
 Future.PRINT 10, 459 - Y, msgs$(G), 0, 223
 Y = Y + 17
NEXT i
DrawBar


END SUB

SUB Pause
 DO: LOOP UNTIL INKEY$ <> ""
END SUB

DEFINT A-Z
SUB SaveBDT (file2$)
SetPage 2
  IF file2$ <> "" THEN
'   UpdateTempMap (currentmap)
   CLOSE
   OPEN file2$ FOR OUTPUT AS #1
   WRITE #1, tileset$
  FOR mapno = 1 TO 100
    FOR i = 1 + yoff TO 25 + yoff
     line$ = ""
     FOR X = 1 + xoff TO 40 + xoff
      a = Future.POINT(X, i)
      IF a >= 0 AND a < 256 THEN
       C$ = CHR$(a)
      END IF
      line$ = line$ + C$
     NEXT X
     PRINT #1, line$
    NEXT i
    xoff = xoff + 40
    IF RIGHT$(STR$(mapno), 1) = "0" THEN
     ' i was stuck for like ten minutes on the above condition
     'cos i used a left instead of a right!! far ouout
     xoff = 0
     yoff = yoff + 25
    END IF
  NEXT mapno
  END IF
  CLOSE
SetPage Primary%

END SUB

DEFSNG A-Z
SUB ShowWays
      CX = unit(selu).X
      CX = CX - MapGlobalX(currentmap + 0)
      CY = unit(selu).Y
      CY = CY - MapGlobalY(currentmap + 0)
      FOR z = 1 TO 40
       SELECT CASE MID$(USERWPT$, z, 1)
        CASE "-"
         C = 7
        CASE "w"
         CY = CY - 1
         C = 1
        CASE "s"
         CY = CY + 1
         C = 2
        CASE "a"
         CX = CX - 1
         C = 3
        CASE "d"
         CX = CX + 1
         C = 4
        CASE ELSE
         C = 14
         EXIT FOR
       END SELECT
       Future.BOX CX * 15 + 3, CY * 15 + 3, CX * 15 + 10, CY * 15 + 10, C
      NEXT z
      MSG USERWPT$

END SUB

SUB TraceWays (Tx, Ty, ox, oy, WPT$)
WPT$ = ""
CX = ox
CY = oy
IF Collide(ox, oy) THEN MSG "Stuck in wall!"
IF Collide(Tx, Ty) THEN solidTarget% = 1
IF mounted THEN rn = 20 ELSE rn = 120
FOR z = 1 TO rn
 lmvd = mvd
 mvd = 0
 FOR P = 1 TO 30
  IF Tx > CX AND NOT Collide(CX + 1, CY) AND mvd = 0 AND lmvd <> 2 THEN CX = CX + 1: mvd = 1
  IF Tx < CX AND NOT Collide(CX - 1, CY) AND mvd = 0 AND lmvd <> 1 THEN CX = CX - 1: mvd = 2
  IF Ty > CY AND NOT Collide(CX, CY + 1) AND mvd = 0 AND lmvd <> 4 THEN CY = CY + 1: mvd = 3
  IF Ty < CY AND NOT Collide(CX, CY - 1) AND mvd = 0 AND lmvd <> 3 THEN CY = CY - 1: mvd = 4
  IF mvd > 0 THEN EXIT FOR
  IF Collide(Tx, Ty) THEN EXIT FOR
  IF Tx < CX AND NOT Collide(CX + 1, CY) AND mvd = 0 AND lmvd <> 2 THEN CX = CX + 1: mvd = 1
  IF Tx > CX AND NOT Collide(CX - 1, CY) AND mvd = 0 AND lmvd <> 1 THEN CX = CX - 1: mvd = 2
  IF Ty < CY AND NOT Collide(CX, CY + 1) AND mvd = 0 AND lmvd <> 4 THEN CY = CY + 1: mvd = 3
  IF Ty > CY AND NOT Collide(CX, CY - 1) AND mvd = 0 AND lmvd <> 3 THEN CY = CY - 1: mvd = 4
  IF mvd > 0 THEN EXIT FOR
  IF NOT Collide(CX + 1, CY) AND mvd = 0 AND lmvd <> 2 THEN CX = CX + 1: mvd = 1
  IF NOT Collide(CX - 1, CY) AND mvd = 0 AND lmvd <> 1 THEN CX = CX - 1: mvd = 2
  IF NOT Collide(CX, CY + 1) AND mvd = 0 AND lmvd <> 4 THEN CY = CY + 1: mvd = 3
  IF NOT Collide(CX, CY - 1) AND mvd = 0 AND lmvd <> 3 THEN CY = CY - 1: mvd = 4
  IF mvd = 1 AND lmvd = 2 THEN mvd = 0
  IF mvd = 3 AND lmvd = 4 THEN mvd = 0
  IF mvd = 2 AND lmvd = 1 THEN mvd = 0
  IF mvd = 3 AND lmvd = 3 THEN mvd = 0
  IF mvd > 0 THEN EXIT FOR
 NEXT P
 'IF Collide(Tx, Ty) AND CX = Tx AND CY = Ty THEN WPT$ = WPT$ + "e": MSG "solid tgt": EXIT FOR
 IF bAc > 5 THEN mvd = INT(RND * 4) + 1
 SELECT CASE mvd
  CASE 1
   WPT$ = WPT$ + "d"
  CASE 2
   WPT$ = WPT$ + "a"
  CASE 3
   WPT$ = WPT$ + "s"
  CASE 4
   WPT$ = WPT$ + "w"
 END SELECT
 IF solidTarget% = 1 THEN
  ca = CheckAdjacent%(CX, CY, Tx, Ty)
  IF ca = 1 THEN
   WPT$ = WPT$ + "e"
   'MSG "solid exit"
    EXIT FOR
  END IF
 END IF
 IF CX = Tx AND CY = Ty THEN WPT$ = WPT$ + "e": EXIT FOR
NEXT z
IF Collide(Tx, Ty) THEN WPT$ = WPT$ + "e"
IF INSTR(WPT$, "e") < 1 THEN MSG "unfinished wpt"

END SUB

SUB UpdateTempMap (map)
 SetPage 2
 CLOSE
 map$ = "maps\temps\map" + LTRIM$(STR$(map)) + ".tmp"
 OPEN map$ FOR OUTPUT AS #1
 FOR Y = 1 TO 25
  line$ = ""
  FOR X = 1 TO 40
   line$ = line$ + CHR$(Future.POINT(X + MapGlobalX(map + 0), Y + MapGlobalY(map + 0)))
  NEXT X
  PRINT #1, line$
  IF LEN(line$) <> 40 THEN PRINT "ERROR"; LEN(line$): Pause
 NEXT Y
 CLOSE
 SetPage Primary%
END SUB

FUNCTION WhichMap (X, Y)
 ' finds which map x and y are in if x and y are global coords
 x2 = INT(X / 40) + 1
 y2 = INT(Y / 25)
 M = (y2 * 10) + x2
 WhichMap = M
END FUNCTION

